@echo off

:: The following has been taken from: http://stackoverflow.com/a/10052222
:: BatchGotAdmin

set FOLDER_LOCATION=%~dp0

REM Checking if we can access system folder
if "%PROCESSOR_ARCHITECTURE%" EQU "amd64" (
>nul 2>&1 "%SYSTEMROOT%\SysWOW64\cacls.exe" "%SYSTEMROOT%\SysWOW64\config\system"
) else (
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
)

REM Requesting admin privileges for installing the service if non-admin user is detected
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UacPrompt
) else (
    goto AlreadyAdmin
)

:UacPrompt
    echo set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"="
    echo UAC.ShellExecute "cmd.exe", "/c ""%~s0"" %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /b

:AlreadyAdmin
    pushd "%cd%"
    cd /d "%FOLDER_LOCATION%"


REM Checking if a server file is already configured
if not exist "%FOLDER_LOCATION%..\server\config.yaml" (
    echo msgbox "File 'server\config.yaml' not found!" ^& vbNewLine ^& vbNewLine ^& "Please make sure you create it before installing the service.", 48, "payworks Pay Server Service" > %tmp%\alert.vbs
    cscript /nologo %tmp%\alert.vbs
    del %tmp%\alert.vbs
    exit /b
)

REM Installing the PayServer service
nssm\nssm install PayServer "%FOLDER_LOCATION%..\server\run-server.bat"
nssm\nssm set PayServer DisplayName "payworks Pay Server"
nssm\nssm set PayServer Description "This service is used to execute and manage payworks transactions and devices."
nssm\nssm set PayServer ObjectName "NT AUTHORITY\LocalService" ""

REM Checking if the service was installed correctly
if '%errorlevel%' NEQ '0' (
    echo msgbox "You provided a wrong user or password. The service will be uninstalled.", 48, "payworks PayServer Service" > %tmp%\alert.vbs
    cscript /nologo %tmp%\alert.vbs
    del %tmp%\alert.vbs
    remove-service.bat
    exit /b
)

REM Granting access to LocalService user to PayServer directory
icacls "../." /grant LocalService:(OI)(CI)(RX)
icacls "../." /grant LocalService:(OI)(CI)(W)

REM Starting the PayServer
nssm\nssm start PayServer


REM Final check on the health
cscript /nologo scripts\check-service-running.vbs

for /F "usebackq tokens=*" %%r in (`cscript /nologo "%FOLDER_LOCATION%scripts\check-service-running.vbs"`) do set result=%%r
if %result% EQU 0 (
    echo msgbox "PayServer service installed and running smoothly." ^& vbNewLine ^& vbNewLine ^& "Happy processing!", 64, "PayServer Service" > %tmp%\alert.vbs
) else if %result% EQU 1 (
    echo msgbox "PayServer service installed but could not be started." ^& vbNewLine ^& vbNewLine ^& "Please check your config.yaml and the status of the service in the Service Manager.", 48, "PayServer Service" > %tmp%\alert.vbs
) else if %result% EQU 2 (
    echo msgbox "PayServer service could not be installed." ^& vbNewLine ^& vbNewLine ^& "This is unexpected, please contact support.", 16, "PayServer Service" > %tmp%\alert.vbs
)
cscript /nologo %tmp%\alert.vbs
del %tmp%\alert.vbs